//--------------------------------------------------------------------------------------------------------------------//
//                                                DX8 SWAP CHAIN CLASS                                                //
//                                                (MULTIPLE VIEWS)                                                    //
// 22/05/02, Mythos                                                                                                   //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _MYTHOS_SWAPCHAINDX8_INL_
#define   _MYTHOS_SWAPCHAINDX8_INL_
#pragma    once

//--------------------------------------------------------------------------------------------------------------------//
//                                                CONSTRUCTORS / DESTRUCTOR                                           //
//--------------------------------------------------------------------------------------------------------------------//

INLINE Mythos::CSwapChainDX8::CSwapChainDX8(u32 u32Handle,bool boWindowed,bool boZBuffer,HWND hWnd,u32 u32Width,u32 u32Height) :
                              CSwapChain(u32Handle,boWindowed,boZBuffer,hWnd,u32Width,u32Height)
  {
  m_pInterface  = NULL;
  m_pBackBuffer = NULL;
  m_pZStencil   = NULL;
  }

INLINE Mythos::CSwapChainDX8::~CSwapChainDX8()
  {
  if(m_pBackBuffer) m_pBackBuffer->Release();
  if(m_pZStencil)   m_pZStencil  ->Release();
  if(m_pInterface)  m_pInterface ->Release();               // order is important to avoid D3D warnings in output

  m_pInterface  = NULL;
  m_pBackBuffer = NULL;
  m_pZStencil   = NULL;
  }

//--------------------------------------------------------------------------------------------------------------------//
//                                                GET/SET                                                             //
//--------------------------------------------------------------------------------------------------------------------//

INLINE IDirect3DSwapChain8* Mythos::CSwapChainDX8::GetInterface() const
  {
  return m_pInterface;
  }

INLINE void Mythos::CSwapChainDX8::SetInterface(IDirect3DSwapChain8* pInterface)
  {
  if(m_pInterface) m_pInterface->Release();
  m_pInterface = pInterface;
  }

INLINE IDirect3DSurface8* Mythos::CSwapChainDX8::GetBackBuffer() const
  {
  return m_pBackBuffer;
  }

INLINE void Mythos::CSwapChainDX8::SetBackBuffer(IDirect3DSurface8* pBackBuffer)
  {
  if(m_pBackBuffer) m_pBackBuffer->Release();
  m_pBackBuffer = pBackBuffer;
  }

INLINE IDirect3DSurface8* Mythos::CSwapChainDX8::GetZStencil() const
  {
  return m_pZStencil;
  }

INLINE void Mythos::CSwapChainDX8::SetZStencil(IDirect3DSurface8* pZStencil)
  {
  if(m_pZStencil) m_pZStencil->Release();
  m_pZStencil = pZStencil;
  }

//--------------------------------------------------------------------------------------------------------------------//

#endif // _MYTHOS_SWAPCHAINDX8_INL_
